#include<stdio.h>
#include<stdlib.h>
#include"dSFMT.h"

#define Number	10000		//trial number
#define MaxTime	20			//the maximum time
#define p	0.6				//the probability of moving
#define q	0.4				//the probability of stopping
dsfmt_t dsfmt1;


int main(void){
	int i,j;
	double rand;
	
	int **x;		//x[trialNo][time]
	//two demension calloc
	x = (int **)calloc( Number , sizeof(int *) );
	for( i=0 ; i<Number ; i++){
		x[i] = (int *)calloc( MaxTime + 1, sizeof(int));
	}
	//
	
	
	for(i=0 ; i<Number ; i++){	//trial number
		dsfmt_init_gen_rand(&dsfmt1,i);		//Seed of random number
		
		for( j=1 ; j<=MaxTime ; j++){		//Time
			rand = dsfmt_genrand_close_open(&dsfmt1);
			
			
			//the action depends on random number
			if(rand < p/2.0)			x[i][j] = x[i][j-1] + 1.0;
			else if (rand >= 1-p/2.0) 	x[i][j] = x[i][j-1] - 1.0;
			else 						x[i][j] = x[i][j-1];
			
		}
	}
	
	int *count;	//count[x] :
	char *fn;
	fn = (char *)calloc(100 , sizeof(char) );
	FILE *fp;
	
	
	for(j=1; j<= MaxTime ; j++){	//record the position at time j
		count = (int *)calloc( 2*j+1 , sizeof(int) );
		
		sprintf(fn , "count3_4_4_1/count_%d.dat",j);	//file name depends on j
		if( ( fp = fopen( fn , "w") ) == NULL){
			printf("File Error : %d\n" , j);
			exit(1);
		}
		
		for(i=0 ; i<Number ; i++){
			count[ x[i][j] + j ] += 1;
		}
		
		for( i=0 ; i< 2*j+1 ; i++){
			fprintf(fp , "%d	%d\n" , i-j , count[i]);
		}
		
		fclose(fp);
		free(count);
	}
	
	
	
	for(i=0;i<Number;i++)	free(x[i]);
	return 0;
}


